package de.arminwolf.controllers;

import de.arminwolf.models.dto.LoginRequestDTO;
import de.arminwolf.models.dto.RegistrationRequestDTO;
import de.arminwolf.models.dto.UserDTO;
import de.arminwolf.services.AuthenticationService;
import lombok.AllArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.net.URI;


@AllArgsConstructor
@RestController
public class AuthenticationController {

	private final AuthenticationService authenticationService;

	@PostMapping("/login")
	public ResponseEntity<UserDTO> login(@RequestBody LoginRequestDTO loginRequestDTO) {
		return ResponseEntity.ok(authenticationService.login(loginRequestDTO));
	}


	@PostMapping("/register")
	public ResponseEntity<UserDTO> register(@RequestBody RegistrationRequestDTO registerRequestDTO) {
		UserDTO registeredUser = authenticationService.register(registerRequestDTO);
		return ResponseEntity
				.created(URI.create("/users/" + registeredUser.getId()))
				.body(registeredUser);
	}
}
