package de.arminwolf.models.mapper;


import de.arminwolf.models.User;
import de.arminwolf.models.dto.RegistrationRequestDTO;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.password.PasswordEncoder;

@Mapper(componentModel = "spring")
public abstract class RegistrationMapper {

	@Autowired
	protected PasswordEncoder passwordEncoder;


	@Mapping(target = "password", qualifiedByName ="passwordMapping")
	public abstract User registrationRequestDTOToUser(RegistrationRequestDTO registrationRequestDTO);


	@Named("passwordMapping")
	String passwordMapping(String password) {
		return this.passwordEncoder.encode(password);
	}
}
