package de.arminwolf.services;

import de.arminwolf.models.Role;
import de.arminwolf.repositories.RoleRepository;
import jakarta.transaction.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

@Service
public class RoleService {

	@Autowired
	RoleRepository repository;


	public Set<Role> getAllRoles() {
		return new HashSet<>(repository.findAll());
	}

	public Role getDefaultRole() {
		Role user = repository.findByName("USER");
		if (Objects.nonNull(user)) {
			return user;
		} else {
			return createRoleByName("USER");
		}
	}

	public Role getAdminRole() {
		Role admin = repository.findByName("ADMIN");
		if (Objects.nonNull(admin)) {
			return admin;
		} else {
			return createRoleByName("ADMIN");
		}
	}


	@Transactional
	private Role createRoleByName(final String name) {
		Role role = Role.builder().name(name).build();
		repository.save(role);
		return role;
	}


}
